package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.*;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.entity.UserBalanceLog;
import com.gxwebsoft.common.system.param.UserBalanceLogParam;
import com.gxwebsoft.common.system.service.UserBalanceLogService;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户余额变动明细表控制器
 *
 * @author 科技小王子
 * @since 2023-04-21 15:59:09
 */
@Tag(name = "用户余额明细")
@RestController
@RequestMapping("/api/sys/user-balance-log")
public class UserBalanceLogController extends BaseController {
    @Resource
    private UserBalanceLogService userBalanceLogService;

    @PreAuthorize("hasAuthority('sys:userBalanceLog:list')")
    @OperationLog
    @Operation(summary = "分页查询用户余额变动明细表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserBalanceLog>> page(UserBalanceLogParam param) {
        // 使用关联查询
        return success(userBalanceLogService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:list')")
    @OperationLog
    @Operation(summary = "查询全部用户余额变动明细表")
    @GetMapping()
    public ApiResult<List<UserBalanceLog>> list(UserBalanceLogParam param) {
        PageParam<UserBalanceLog, UserBalanceLogParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(userBalanceLogService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(userBalanceLogService.listRel(param));
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:list')")
    @OperationLog
    @Operation(summary = "根据id查询用户余额变动明细表")
    @GetMapping("/{id}")
    public ApiResult<UserBalanceLog> get(@PathVariable("id") Integer id) {
        return success(userBalanceLogService.getById(id));
        // 使用关联查询
        //return success(userBalanceLogService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:save')")
    @OperationLog
    @Operation(summary = "添加用户余额变动明细表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserBalanceLog userBalanceLog) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userBalanceLog.setUserId(loginUser.getUserId());
        }
        if (userBalanceLogService.save(userBalanceLog)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:update')")
    @OperationLog
    @Operation(summary = "修改用户余额变动明细表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserBalanceLog userBalanceLog) {
        if (userBalanceLogService.updateById(userBalanceLog)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:remove')")
    @OperationLog
    @Operation(summary = "删除用户余额变动明细表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userBalanceLogService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:save')")
    @OperationLog
    @Operation(summary = "批量添加用户余额变动明细表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserBalanceLog> list) {
        if (userBalanceLogService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:update')")
    @OperationLog
    @Operation(summary = "批量修改用户余额变动明细表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserBalanceLog> batchParam) {
        if (batchParam.update(userBalanceLogService, "log_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:userBalanceLog:remove')")
    @OperationLog
    @Operation(summary = "批量删除用户余额变动明细表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userBalanceLogService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
